/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* Username at www.hmgforum.com - Zimbo                                  *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"

/* -------------------------------------------------------------------- */

FUNCTION Main()

DEFINE WINDOW       Win_1           ;
    ROW             10              ;
    COL             10              ;
    WIDTH           500             ;
    HEIGHT          300             ;
    TITLE           "The NOCAPTION Property" ;
    ICON            "HMG Guide.ico" ;
    WINDOWTYPE      MAIN            ;
    FONTNAME        "Arial"         ;
    FONTSIZE        10              ;

    DEFINE BUTTON   btnNoCapOn
        ROW         30
        COL         40
        WIDTH       100
        HEIGHT      30
        ACTION      ToggleCaption(.T.)
        CAPTION     "No Caption ON"
        FONTNAME    "Arial"
        FONTSIZE    8
        TOOLTIP     ""
    END BUTTON

    DEFINE BUTTON   btnNoCapOff
        ROW         80
        COL         40
        WIDTH       100
        HEIGHT      30
        ACTION      ToggleCaption(.F.)
        CAPTION     "No Caption OFF"
        FONTNAME    "Arial"
        FONTSIZE    8
        TOOLTIP     ""
    END BUTTON

    DEFINE LABEL    lbl1
        ROW         130
        COL         40
        WIDTH       400
        HEIGHT      30
        VALUE       "The NOCAPTION Property for this Window is set to: " + ;
                    IF(Win_1.NOCAPTION, "False", "True")
        TRANSPARENT .T.
    END LABEL

END WINDOW

ACTIVATE WINDOW Win_1

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION ToggleCaption(lVal)

IF lVal
        Win_1.NOCAPTION := .T.
        Win_1.lbl1.VALUE := "The NOCAPTION Property is set to: True"
    ELSE
        Win_1.NOCAPTION := .F.
        Win_1.lbl1.VALUE := "The NOCAPTION Property is set to: False"
ENDIF

RETURN nil

/* -------------------------------------------------------------------- */
