/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* Username at www.hmgforum.com - Zimbo                                  *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"

/* -------------------------------------------------------------------- */

FUNCTION Main()

DEFINE WINDOW       Win_1           ;
    ROW             10              ;
    COL             10              ;
    WIDTH           500             ;
    HEIGHT          300             ;
    TITLE           "The NOMAXIMIZE Property" ;
    ICON            "HMG Guide.ico" ;
    WINDOWTYPE      MAIN            ;
    FONTNAME        "Arial"         ;
    FONTSIZE        10              ;

    DEFINE BUTTON   btnNoMaxOn
        ROW         30
        COL         40
        WIDTH       100
        HEIGHT      30
        ACTION      ToggleMax(.T.)
        CAPTION     "No Maximize ON"
        FONTNAME    "Arial"
        FONTSIZE    8
        TOOLTIP     ""
    END BUTTON

    DEFINE BUTTON   btnNoMaxOff
        ROW         80
        COL         40
        WIDTH       100
        HEIGHT      30
        ACTION      ToggleMax(.F.)
        CAPTION     "No Maximize OFF"
        FONTNAME    "Arial"
        FONTSIZE    8
        TOOLTIP     ""
    END BUTTON

    DEFINE LABEL    lbl1
        ROW         130
        COL         40
        WIDTH       400
        HEIGHT      30
        VALUE       "The NOMAXIMIZE Property for this Window is set to: " + ;
                    IF(Win_1.NOMAXIMIZE, "False", "True")
        TRANSPARENT .T.
    END LABEL

END WINDOW

ACTIVATE WINDOW Win_1

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION ToggleMax(lVal)

IF lVal
        Win_1.NOMAXIMIZE := .T.
        Win_1.lbl1.VALUE := "The NOMAXIMIZE Property is set to: True"
    ELSE
        Win_1.NOMAXIMIZE := .F.
        Win_1.lbl1.VALUE := "The NOMAXIMIZE Property is set to: False"
ENDIF

RETURN nil

/* -------------------------------------------------------------------- */
