/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* WinTabbed-Def.prg is a sample program to demonstrate how to create a  *
* Window that contains a number of Pages in a tabulated layout          *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* www.hmgforum.com - @Zimbo                                             *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"


/* -------------------------------------------------------------------- */

FUNCTION Main()

DEFINE WINDOW      Win_1                 ;
    ROW            10                    ;
    COL            10                    ;
    WIDTH          500                   ;
    HEIGHT         300                   ;
    TITLE          "The NOSIZE Property" ;
    ICON           "HMG Guide.ico"       ;
    WINDOWTYPE     MAIN                  ;
    FONTNAME       "Arial"               ;
    FONTSIZE       10                    ;

    DEFINE BUTTON   btnNoSizeOn
        ROW         30
        COL         40
        WIDTH       100
        HEIGHT      30
        ACTION      ToggleSize(.T.)
        CAPTION     "No Size ON"
        FONTNAME    "Arial"
        FONTSIZE    8
        TOOLTIP     ""
    END BUTTON

    DEFINE BUTTON   btnNoSizeOff
        ROW         80
        COL         40
        WIDTH       100
        HEIGHT      30
        ACTION      ToggleSize(.F.)
        CAPTION     "No Size OFF"
        FONTNAME    "Arial"
        FONTSIZE    8
        TOOLTIP     ""
    END BUTTON

    DEFINE LABEL    lbl1
        ROW         130
        COL         40
        WIDTH       400
        HEIGHT      30
        VALUE       "The NOSIZE Property for this Window is set to: " + ;
                    IF(Win_1.NOSIZE, "False", "True")
        TRANSPARENT .T.
    END LABEL

END WINDOW

ACTIVATE WINDOW Win_1

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION ToggleSize(lVal)

IF lVal
        Win_1.NOSIZE := .T.
        Win_1.lbl1.VALUE := "The NOSIZE Property is set to: True"
    ELSE
        Win_1.NOSIZE := .F.
        Win_1.lbl1.VALUE := "The NOSIZE Property is set to: False"
ENDIF

RETURN nil

/* -------------------------------------------------------------------- */
