/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* Username at www.hmgforum.com - Zimbo                                  *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"

/* -------------------------------------------------------------------- */

// File wide static values can be accessed by any function within this
// code file
STATIC nWidth  := 500, nHeight  := 300
STATIC nVWidth := 750, nVHeight := 500

FUNCTION Main()

DEFINE WINDOW       Win_1           ;
    ROW             10              ;
    COL             10              ;
    WIDTH           nWidth          ;   // Client Area = 467
    HEIGHT          nHeight         ;   // Client Area = 244
    VIRTUALWIDTH    nVWidth         ;
    VIRTUALHEIGHT   nVHeight        ;
    TITLE           "The VSCROLLBAR and HSCROLLBAR Controls" ;
    ICON            "HMG Guide.ico" ;
    WINDOWTYPE      MAIN            ;
    FONTNAME        "Arial"         ;
    FONTSIZE        12              ;
    ONINIT          SizeChange()    ;
    ONSIZE          SizeChange()    ;
    ONMAXIMIZE      SizeChange()    ;
    ONSCROLLUP      SizeChange()    ;
    ONSCROLLDOWN    SizeChange()    ;
    ONSCROLLLEFT    SizeChange()    ;
    ONSCROLLRIGHT   SizeChange()    ;
    ONHSCROLLBOX    SizeChange()    ;
    ONVSCROLLBOX    SizeChange()    ;

    DEFINE LABEL    LblIns
        ROW         10
        COL         10
        HEIGHT      40
        WIDTH       450
        VALUE       "Change position with the horizontal and/or " + ;
                    "vertical scroll bars, re-size the Window or" + ;
                    " Maximize it!"
        TRANSPARENT .F.
        AUTOSIZE    .F.
    END LABEL
    
    DEFINE LABEL    Lbl1
        ROW         60
        COL         10
        HEIGHT      20
        WIDTH       400
        VALUE       ""
        TRANSPARENT .F.
        AUTOSIZE    .F.
    END LABEL

    DEFINE LABEL    Lbl2
        ROW         90
        COL         10
        HEIGHT      20
        WIDTH       400
        VALUE       ""
        TRANSPARENT .F.
        AUTOSIZE    .F.
    END LABEL

    DEFINE LABEL    Lbl3
        ROW         120
        COL         10
        HEIGHT      20
        WIDTH       400
        VALUE       ""
        TRANSPARENT .F.
        AUTOSIZE    .F.
    END LABEL
    
    DEFINE LABEL    Lbl4
        ROW         150
        COL         10
        HEIGHT      20
        WIDTH       400
        VALUE       ""
        TRANSPARENT .F.
        AUTOSIZE    .F.
    END LABEL    
    
END WINDOW

ACTIVATE WINDOW Win_1

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION SizeChange()

// Unable to find a way to re-position the window so that the client area
// is re-positioned when resized beyond virtual dimension or maximized

// Check the width. If bigger than Virtual Width, disable the scroll bar
IF Win_1.CLIENTAREAWIDTH  >= (nVWidth)
        Win_1.HSCROLL     := .F.
    ELSE
        Win_1.HSCROLL     := .T.    // Enable the scroll bar
ENDIF

// Check the Height. If bigger than Virtual Height, disable the scroll bar
IF Win_1.CLIENTAREAHEIGHT >= (nVHeight)
        Win_1.VSCROLL     := .F.
    ELSE
        Win_1.VSCROLL     := .T.    // Enable the scroll bar
ENDIF

// Update the Scroll bar values
IF Win_1.VSCROLL
        Win_1.lbl1.VALUE   := "VSCROLLBAR Control Value: " + ;
                               ALLTRIM(STR(Win_1.VSCROLLBAR.VALUE))
    ELSE
        Win_1.lbl1.VALUE   := "The VSCROLLBAR Control is OFF"
ENDIF

// Update the Scroll bar values
IF Win_1.HSCROLL
        Win_1.lbl2.VALUE   := "HSCROLLBAR Control Value: " + ;
                               ALLTRIM(STR(Win_1.HSCROLLBAR.VALUE))
    ELSE
        Win_1.lbl2.VALUE   := "The HSCROLLBAR Control is OFF"
ENDIF

// Update the Client Area values
Win_1.lbl3.VALUE   := "Client Area Width: " + ;
                       ALLTRIM(STR(Win_1.CLIENTAREAWIDTH))
Win_1.lbl4.VALUE   := "Client Area Height: " + ;
                       ALLTRIM(STR(Win_1.CLIENTAREAHEIGHT))

RETURN nil

/* -------------------------------------------------------------------- */