/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* Username at www.hmgforum.com - Zimbo                                  *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"

/* -------------------------------------------------------------------- */

FUNCTION Main()

DEFINE WINDOW       Win_1           ;
    ROW             10              ;
    COL             10              ;
    WIDTH           500             ;
    HEIGHT          300             ;
    TITLE           "The ANIMATE WINDOW Command" ;
    ICON            "HMG Guide.ico" ;
    WINDOWTYPE      MAIN            ;
    FONTNAME        "Arial"         ;
    FONTSIZE        8               ;

    DEFINE LABEL    lbl1
        ROW         2
        COL         75
        FONTSIZE    10
        VALUE       " With INTERVAL 800 "
        AUTOSIZE    .T.
        TRANSPARENT .T.
    END LABEL
    
    DEFINE LABEL    lbl2
        ROW         2
        COL         270
        FONTSIZE    10
        VALUE       "      No INTERVAL  "
        AUTOSIZE    .T.
        TRANSPARENT .T.
    END LABEL
    
    DEFINE BUTTON btnAnim1
        ROW         20
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(1)
        CAPTION     "AW_HOR_POSITIVE"
        FONTNAME    "Arial"
        TRANSPARENT .T.
    END BUTTON
    
    DEFINE BUTTON btnAnim2
        ROW         45
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(2)
        CAPTION     "AW_HOR_NEGATIVE"
        TRANSPARENT .T.
    END BUTTON
 
    DEFINE BUTTON btnAnim3
        ROW         70
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(3)
        CAPTION     "AW_VER_POSITIVE"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnAnim4
        ROW         95
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(4)
        CAPTION     "AW_VER_NEGATIVE"
        TRANSPARENT .T.
    END BUTTON
    
    DEFINE BUTTON btnAnim5
        ROW         120
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(5)
        CAPTION     "AW_CENTER"
        TRANSPARENT .T.
    END BUTTON
    
    DEFINE BUTTON btnAnim6
        ROW         145
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(6)
        CAPTION     "AW_HIDE"
        TRANSPARENT .T.
    END BUTTON
    
    DEFINE BUTTON btnAnim7
        ROW         170
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(7)
        CAPTION     "AW_ACTIVATE"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnAnim8
        ROW         195
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(8)
        CAPTION     "AW_SLIDE"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnAnim9
        ROW         220
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(9)
        CAPTION     "AW_BLEND"
        TRANSPARENT .T.
    END BUTTON
    
    DEFINE BUTTON btnAnim10
        ROW         20
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(10)
        CAPTION     "AW_HOR_POSITIVE"
        FONTNAME    "Arial"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnAnim11
        ROW         45
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(11)
        CAPTION     "AW_HOR_NEGATIVE"
        TRANSPARENT .T.
    END BUTTON
 
    DEFINE BUTTON btnAnim12
        ROW         70
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(12)
        CAPTION     "AW_VER_POSITIVE"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnAnim13
        ROW         95
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(13)
        CAPTION     "AW_VER_NEGATIVE"
        TRANSPARENT .T.
    END BUTTON
    
    DEFINE BUTTON btnAnim14
        ROW         120
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(14)
        CAPTION     "AW_CENTER"
        TRANSPARENT .T.
    END BUTTON
    
    DEFINE BUTTON btnAnim15
        ROW         145
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(15)
        CAPTION     "AW_HIDE"
        TRANSPARENT .T.
    END BUTTON
    
    DEFINE BUTTON btnAnim16
        ROW         170
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(16)
        CAPTION     "AW_ACTIVATE"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnAnim17
        ROW         195
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(17)
        CAPTION     "AW_SLIDE"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnAnim18
        ROW         220
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinAnim(18)
        CAPTION     "AW_BLEND"
        TRANSPARENT .T.
    END BUTTON
    
END WINDOW

ACTIVATE WINDOW Win_1

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION WinAnim(nWhich)                  

DO CASE

    // INTERVAL is an optional parameter used to slow down the animation

    CASE nWhich == 1
        Win_1.HIDE
        ANIMATE WINDOW Win_1 INTERVAL 800 MODE AW_HOR_POSITIVE
        Win_1.SHOW
    CASE nWhich == 2
        Win_1.HIDE
        ANIMATE WINDOW Win_1 INTERVAL 800 MODE AW_HOR_NEGATIVE
        Win_1.SHOW
    CASE nWhich == 3
        Win_1.HIDE
        ANIMATE WINDOW Win_1 INTERVAL 800 MODE AW_VER_POSITIVE
        Win_1.SHOW
    CASE nWhich == 4
        Win_1.HIDE
        ANIMATE WINDOW Win_1 INTERVAL 800 MODE AW_VER_NEGATIVE
        Win_1.SHOW
    CASE nWhich == 5
        Win_1.HIDE
        ANIMATE WINDOW Win_1 INTERVAL 800 MODE AW_CENTER
        Win_1.SHOW
    CASE nWhich == 6
        Win_1.HIDE
        ANIMATE WINDOW Win_1 INTERVAL 800 MODE AW_HIDE
        Win_1.SHOW
    CASE nWhich == 7
        Win_1.HIDE
        ANIMATE WINDOW Win_1 INTERVAL 800 MODE AW_ACTIVATE
        Win_1.SHOW
    CASE nWhich == 8
        Win_1.HIDE
        ANIMATE WINDOW Win_1 INTERVAL 800 MODE AW_SLIDE
        Win_1.SHOW
    CASE nWhich == 9
        Win_1.HIDE
        ANIMATE WINDOW Win_1 INTERVAL 800 MODE AW_BLEND
        Win_1.SHOW
        
    // INTERVAL removed

    CASE nWhich == 10
        Win_1.HIDE
        ANIMATE WINDOW Win_1 MODE AW_HOR_POSITIVE
        Win_1.SHOW
    CASE nWhich == 11
        Win_1.HIDE
        ANIMATE WINDOW Win_1 MODE AW_HOR_NEGATIVE
        Win_1.SHOW
    CASE nWhich == 12
        Win_1.HIDE
        ANIMATE WINDOW Win_1 MODE AW_VER_POSITIVE
        Win_1.SHOW
    CASE nWhich == 13
        Win_1.HIDE
        ANIMATE WINDOW Win_1 MODE AW_VER_NEGATIVE
        Win_1.SHOW
    CASE nWhich == 14
        Win_1.HIDE
        ANIMATE WINDOW Win_1 MODE AW_CENTER
        Win_1.SHOW
    CASE nWhich == 15
        Win_1.HIDE
        ANIMATE WINDOW Win_1 MODE AW_HIDE
        Win_1.SHOW
    CASE nWhich == 16
        Win_1.HIDE
        ANIMATE WINDOW Win_1 MODE AW_ACTIVATE
        Win_1.SHOW
    CASE nWhich == 17
        Win_1.HIDE
        ANIMATE WINDOW Win_1 MODE AW_SLIDE
        Win_1.SHOW       
    CASE nWhich == 18
        Win_1.HIDE
        ANIMATE WINDOW Win_1 MODE AW_BLEND
        Win_1.SHOW        
ENDCASE

RETURN nil

/* -------------------------------------------------------------------- */
