/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* Username at www.hmgforum.com - Zimbo                                  *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"

/* -------------------------------------------------------------------- */

FUNCTION Main()

DEFINE WINDOW       Win_1           ;
    ROW             10              ;
    COL             10              ;
    WIDTH           500             ;
    HEIGHT          300             ;
    TITLE           "The CENTER WINDOW Command" ;
    ICON            "HMG Guide.ico" ;
    WINDOWTYPE      MAIN            ;
    FONTNAME        "Arial"         ;
    FONTSIZE        8               ;

    DEFINE LABEL    lbl1
        ROW         5
        COL         50
        FONTSIZE    10
        VALUE       "Methods"
        AUTOSIZE    .T.
        TRANSPARENT .T.
    END LABEL
    
    DEFINE BUTTON btnMeth1
        ROW         30
        COL         10
        WIDTH       125
        HEIGHT      22
        ACTION      WinCenter(1)
        CAPTION     "Center Method 1"
        TRANSPARENT .T.
        TOOLTIP     "Win_1.CENTER Method"
    END BUTTON
    
    DEFINE BUTTON btnMeth2
        ROW         60
        COL         10
        WIDTH       125
        HEIGHT      22
        ACTION      WinCenter(2)
        CAPTION     "Center Method 2"
        TRANSPARENT .T.
        TOOLTIP     "Win_1.CENTERIN Method"
    END BUTTON

    DEFINE LABEL    lbl2
        ROW         58
        COL         150
        WIDTH       325
        HEIGHT      40
        FONTSIZE    8
        VALUE       "(A temporary second Window will be shown, this " + ;
                    "Window will then be centered over it and the " + ;
                    "temporary Window will close)"
        TRANSPARENT .T.
    END LABEL
    
    DEFINE LABEL    lbl3
        ROW         90
        COL         40
        FONTSIZE    10
        VALUE       "Commands"
        AUTOSIZE    .T.
        TRANSPARENT .T.
    END LABEL

    DEFINE BUTTON btnCmd1
        ROW         115
        COL         10
        WIDTH       125
        HEIGHT      22
        ACTION      WinCenter(3)
        CAPTION     "Center Command 1"
        TRANSPARENT .T.
        TOOLTIP     "CENTER Win_1 Command"
    END BUTTON

    DEFINE BUTTON btnCmd2
        ROW         145
        COL         10
        WIDTH       125
        HEIGHT      22
        ACTION      WinCenter(4)
        CAPTION     "Center Command 2"
        TRANSPARENT .T.
        TOOLTIP     "CENTER Win_1 in Win_ 2 Command"
    END BUTTON
    
    DEFINE LABEL    lbl4
        ROW         143
        COL         150
        WIDTH       325
        HEIGHT      40
        FONTSIZE    8
        VALUE       "(A temporary second Window will be shown, this " + ;
                    "Window will then be centered over it and the " + ;
                    "temporary Window will close)"
        TRANSPARENT .T.
    END LABEL
    
END WINDOW

DEFINE WINDOW       Win_2           ;
    ROW             50              ;
    COL             800             ;
    WIDTH           600             ;
    HEIGHT          400             ;
    TITLE           "Temp. Window"  ;
    ICON            nil             ;
    WINDOWTYPE      STANDARD        ;
    FONTNAME        "Arial"         ;
    FONTSIZE        8               ;
    VISIBLE         .F.             ;
    
    DEFINE LABEL    lbl1
        ROW         10
        COL         10
        FONTSIZE    10
        VALUE       "Test...."
        AUTOSIZE    .T.
        TRANSPARENT .T.
    END LABEL
    
END WINDOW

ACTIVATE WINDOW Win_1, Win_2

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION WinCenter(nWhich)                  

DO CASE
    CASE nWhich == 1
        Win_1.CENTER
    CASE nWhich == 2
        Win_2.SHOW
        Win_1.CENTERIN(Win_2)
        Win_2.HIDE
    CASE nWhich == 3
        CENTER WINDOW Win_1
    CASE nWhich == 4
        Win_2.SHOW
        CENTER WINDOW Win_1 IN Win_2
        Win_2.HIDE
ENDCASE

RETURN nil

/* -------------------------------------------------------------------- */
