/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* Username at www.hmgforum.com - Zimbo                                  *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"

/* -------------------------------------------------------------------- */

FUNCTION Main()

DEFINE WINDOW           Win_Main            ;
    ROW                 10                  ;
    COL                 10                  ;
    WIDTH               500                 ;
    HEIGHT              300                 ;
    VIRTUALWIDTH        750                 ;
    VIRTUALHEIGHT       500                 ;
    TITLE               "MAIN Windows"      ;
    ICON                "HMG Guide.ico"     ;
    WINDOWTYPE          MAIN                ;
    FONTNAME            "Arial"             ;
    FONTSIZE            12                  ;
    BACKCOLOR           {255 ,255 , 240}    ;
    MINBUTTON           .T.                 ;
    MAXBUTTON           .T.                 ;
    SIZABLE             .T.                 ;
    SYSMENU             .T.                 ;
    TITLEBAR            .T.                 ;
    CURSOR              nil                 ;
    ;//TOPMOST             .T.                 ;    // See Help File!
    VISIBLE             .T.                 ;
    AUTORELEASE         .T.                 ;
    NOTIFYICON          "HMG Guide.ico"     ;
    NOTIFYTOOLTIP       "MAIN Window Notify" ;
    ONNOTIFYCLICK       MsgInfo("MAIN Window Notify Clicked", ;
                                "ONNOTIFYCLICK Event")  ;
    ONINIT              MsgInfo("MAIN Window Program Started", ;
                                "ONINIT Event")  ;
    ONRELEASE           MsgInfo("MAIN Window Released", ;
                                "ONRELEASECLOSE Event") ;
    ONINTERACTIVECLOSE  MsgInfo("MAIN Window Interactively Closed", ;
                                "ONINTERACTIVECLOSE Event") ;
    ONMOUSECLICK        nil                 ;
    ONMOUSEDRAG         nil                 ;
    ONMOUSEMOVE         nil                 ;
    ONSIZE              nil                 ;
    ONMAXIMIZE          MsgInfo("MAIN Window Maximized", ;
                                "ONMAXIMIZE Event")       ;
    ONMINIMIZE          MsgInfo("MAIN Window Minimized", ;
                                "ONMINIMIZE Event")       ;
    ;//ONPAINT             nil                 ;
    ONGOTFOCUS          OnGotFoc()          ;
    ONLOSTFOCUS         OnLostFoc()         ;
    ONSCROLLUP          nil                 ;
    ONSCROLLDOWN        nil                 ;
    ONSCROLLLEFT        nil                 ;
    ONSCROLLRIGHT       nil                 ;
    ONHSCROLLBOX        nil                 ;
    ONVSCROLLBOX        nil                 ;
    ;//HELPBUTTON         .F.                 ;

    DEFINE LABEL        lbl1
        ROW             10
        COL             10
        WIDTH           225
        HEIGHT          20
        VALUE           ""
        TRANSPARENT     .T.
    END LABEL

    DEFINE LABEL        lbl2
        ROW             50
        COL             10
        WIDTH           225
        HEIGHT          20
        VALUE           ""
        TRANSPARENT     .T.
    END LABEL
    
    DEFINE LABEL        lbl3
        ROW             90
        COL             10
        WIDTH           225
        HEIGHT          20 
        VALUE           ""
        TRANSPARENT     .T.
    END LABEL
    
    DEFINE LABEL        lbl4
        ROW             130
        COL             10
        WIDTH           225
        HEIGHT          20 
        VALUE           ""
        TRANSPARENT     .T.
    END LABEL
        
END WINDOW    // Win_Main

ACTIVATE WINDOW Win_Main

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION OnGotFoc()

STATIC nGotFocCnt := 1

Win_Main.lbl1.VALUE := "This Window Has Got Focus "
Win_Main.lbl2.VALUE := "Got Focus Count:  " + ALLTRIM(STR(nGotFocCnt++))

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION OnLostFoc()

STATIC  nLostFocCnt := 1

Win_Main.lbl1.VALUE := ""
Win_Main.lbl1.VALUE := "This Window Has Lost Focus"
Win_Main.lbl3.VALUE := "Lost Focus Count: " + ALLTRIM(STR(nLostFocCnt++))

RETURN nil

/* -------------------------------------------------------------------- */