/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* Username at www.hmgforum.com - Zimbo                                  *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"

/* -------------------------------------------------------------------- */

FUNCTION Main()

DEFINE WINDOW       Win_Main        ;
    ROW             10              ;
    COL             10              ;
    WIDTH           500             ;
    HEIGHT          300             ;
    TITLE           "PANEL Windows" ;
    ICON            "HMG Guide.ico" ;
    WINDOWTYPE      MAIN            ;
    FONTNAME        "Arial"         ;
    FONTSIZE        8               ;
    BACKCOLOR       {255, 255, 240} ;
    ONINIT          nil             ;   // PANEL ONINIT First, then MAIN
    ONRELEASE       nil             ;
    ONINTERACTIVECLOSE nil          ;   // Tested OK - INTERACTIVE MAIN first, ONRELEASE MAIN Second then ONRELEASE PANEL
    
    DEFINE WINDOW            Win_Panel1          ;
        ROW                  25                  ;
        COL                  25                  ;
        WIDTH                200                 ;
        HEIGHT               200                 ;
        TITLE                "Panel 1"           ;   // Ignored
        ICON                 "HMG Guide.ico"     ;   // Ignored
        VIRTUALWIDTH         400                 ;
        VIRTUALHEIGHT        400                 ;
        WINDOWTYPE           PANEL               ;
        FONTNAME             "Arial"             ;
        FONTSIZE             12                  ;
        BACKCOLOR            { 220 , 220, 255 }  ;
        MAXBUTTON            .T.                 ;    // Ignored
        MINBUTTON            .T.                 ;    // Ignored
        SIZABLE              .T.                 ;    // Ignored
        SYSMENU              .T.                 ;    // Ignored
        TITLEBAR             .F.                 ;    // Ignored
        CURSOR               "finger.cur"        ;
        TOPMOST              .T.                 ;    // Ignored
        VISIBLE              .F.                 ;    // Ignored
        AUTORELEASE          .T.                 ;    // Cannot release a PANEL. 
        ONINIT               nil                 ;    // Tested OK - PANEL First, then MAIN
        ONRELEASE            nil                 ;    // Tested OK - INTERACTIVE MAIN first, ONRELEASE MAIN Second then ONRELEASE PANEL
        ONINTERACTIVECLOSE   nil                 ;    // Ignored
        ONMOUSECLICK         nil                 ;    // Tested OK
        ONMOUSEDRAG          nil                 ;    // Tested OK
        ONMOUSEMOVE          nil                 ;    // Tested OK
        ONSIZE               nil                 ;    // Ignored
        ONMAXIMIZE           nil                 ;    // Ignored
        ONMINIMIZE           nil                 ;    // Ignored
        ONPAINT              nil                 ;    // Tested OK
        ONGOTFOCUS           nil                 ;    // Ignored
        ONLOSTFOCUS          nil                 ;    // Ignored
        ONSCROLLUP           nil                 ;    // Tested OK
        ONSCROLLDOWN         nil                 ;    // Tested OK
        ONSCROLLLEFT         nil                 ;    // Tested OK
        ONSCROLLRIGHT        nil                 ;    // Tested OK
        ONHSCROLLBOX         nil                 ;    // Tested OK
        ONVSCROLLBOX         nil                 ;    // Tested OK
        HELPBUTTON           .T.                 ;    // Ignored
        
        // Test Commands - Update Notes accordingly

        DEFINE LABEL    LABEL_1
            ROW         10
            COL         10
            WIDTH       170
            HEIGHT      220
            BACKCOLOR            { 220 , 220, 255 }  
            VALUE       "This is PANEL Window 1 which is defined within a " + ;
                        "MAIN Window which acts as its' 'host'."
            TRANSPARENT .T.
        END LABEL
    END WINDOW          // Win_Panel1
        
    DEFINE WINDOW       Win_Panel2          ;
        ROW             25                  ;
        COL             250                 ;
        WIDTH           200                 ;
        HEIGHT          200                 ;
        WINDOWTYPE      PANEL               ;
        
        DEFINE LABEL    LABEL_1
            ROW         10
            COL         10
            WIDTH       175
            HEIGHT      80
            ONCLICK     nil
            VALUE       "This is PANEL Window 2 which is also defined within the " + ;
                        "same 'host' MAIN Window. However, it is defined as a "   + ;
                        "seperate entity from the PANEL Window 1."
            TRANSPARENT .T.
        END LABEL
        
        DEFINE BUTTON   btnTest
            ROW         150
            COL         55
            WIDTH       100
            HEIGHT      30
            ONCLICK     TestIt()
            CAPTION     "Test"
            TOOLTIP     ""
        END BUTTON

    END WINDOW          // Win_Panel2

    // NOTE: There are three controls within this MAIN window and all are
    // named LABEL_1. This is possible because each one has a different
    // parent Window;
    //     Win_Main.LABEL_1
    //     Win_Panel1.LABEL_1 and 
    //     Win_Panel2.LABEL_1
    //
    // The code snippet below has been tested and works. It demonstrates
    // this parent / control relationship. As an aside,
    // THIS.VALUE := Win_Panel1.LABEL_1.VALUE within the code block also
    // works but I have left it as per below to clearly demonstrate the
    // parent / control relationship
    /*
    DEFINE LABEL    LABEL_1
        ROW         230
        COL         25
        WIDTH       400
        HEIGHT      40
        VALUE       "Yet another Label_1!"
        TRANSPARENT .T.
        ONCLICK     { || Win_Main.LABEL_1.VALUE := Win_Panel1.LABEL_1.VALUE }
    END LABEL
    */

END WINDOW    // Win_Main

ACTIVATE WINDOW Win_Main

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION TestIt()

STATIC lT := .T.

IF lT
        Win_Panel1.HIDE
        lT := .F.
    ELSE
        ANIMATE WINDOW Win_Panel1 INTERVAL 1250 MODE AW_BLEND
        Win_Panel1.SHOW
        lT := .T.
ENDIF

//Win_Main.PRINT

//PRINTWINDOW("Win_Main", .T., .T.)

RETURN nil

/* -------------------------------------------------------------------- */