/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* Username at www.hmgforum.com - Zimbo                                  *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"

/* -------------------------------------------------------------------- */

/*  The MAIN Function hierarchy;
        DEFINE the MAIN Window
            DEFINE a TAB Control
                DEFINE a PAGE on the TAB
                    Create Controls within each PAGE
                END definition of each PAGE
            END definition of the TAB
        END definition of the MAIN Window
*/

FUNCTION Main()

DEFINE WINDOW           Win_Main        ;
    ROW                 10              ;
    COL                 10              ;
    WIDTH               500             ;
    HEIGHT              300             ;
    TITLE               "MAIN Window with TAB Control" ;
    ICON                "HMG Guide.ico" ;
    WINDOWTYPE          MAIN            ;
    FONTNAME            "Arial"         ;
    FONTSIZE            9               ;
    BACKCOLOR           {255, 255, 240} ;
    ONINIT              Win_Main.Tab1.VALUE := 1 ;    // Help file, note 3
    ONRELEASE           nil             ;
    ONINTERACTIVECLOSE  nil             ;
    
    DEFINE TAB          Tab1            ;
        ;//PARENT          Win_Main        ;
		ROW             0               ;
        COL             0               ;
		WIDTH           Win_Main.CLIENTAREAWIDTH  ;
		HEIGHT          Win_Main.CLIENTAREAHEIGHT ;
		VALUE           2               ;
        FONTNAME        "Arial"         ;
        FONTSIZE        9               ;
        ;//FONTBOLD        .F.             ;
        ;//FONTITALIC      .F.             ;
        ;//FONTUNDERLINE   .F.             ;
        ;//FONTSTRIKEOUT   .F.             ;
		;//TOOLTIP         "Tab Control"   ;
        ;//BUTTONS         .F.             ;
        ;//FLAT            .F.             ;
        ;//HOTTRACK        .T.             ;
        ;//VERTICAL        .T.             ;
        ;//ON CHANGE       nil             ;
        ;//TABSTOP         .T.             ;
        ;//MULTILINE       .T.             ;
        ;//TRANSPARENT     .T.             ;

		DEFINE PAGE "Page 1"                      ;
            ;//IMAGE "HMG Guide.ico"                 ;
        
            DEFINE LABEL    P1_LblDesc
            	ROW         30
                COL         10
                VALUE       "Test Selected TAB Properties"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL        
                
            DEFINE BUTTON   P1_Btn1
                PARENT      Win_Main
                ROW         60
                COL         10
                WIDTH       75
                HEIGHT      25
                CAPTION     "Get"
                ONCLICK     MSGINFO( Win_Main.Tab1.CAPTION(4) )
            END BUTTON

            DEFINE LABEL    P1_Lbl1
            	ROW         65
                COL         100
                VALUE       "Get the CAPTION for Page 4"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL  

            // Refer to the associated Help file for TAB (Note 2) regards 
            // the ONCLICK code below!
            DEFINE BUTTON   P1_Btn2
                PARENT      Win_Main
                ROW         100
                COL         10
                WIDTH       75
                HEIGHT      25
                CAPTION     "Set"
                ONCLICK     { || Win_Main.Tab1.HIDE,                   ;
                                 Win_Main.Tab1.CAPTION(4) := "Page Z", ;
                                 Win_Main.Tab1.SHOW                     }
            END BUTTON
            
            DEFINE LABEL    P1_Lbl2
            	ROW         105
                COL         100
                VALUE       "Set a new CAPTION for Page 4"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL  

            DEFINE BUTTON   P1_Btn3
                PARENT      Win_Main
                ROW         140
                COL         10
                WIDTH       75
                HEIGHT      25
                CAPTION     "Page"
                ONCLICK     MSGINFO(Win_Main.Tab1.VALUE)
            END BUTTON
            
            DEFINE LABEL    P1_Lbl3
            	ROW         145
                COL         100
                VALUE       "Get Current Page Number"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL

            DEFINE BUTTON   P1_Btn4
                PARENT      Win_Main
                ROW         180
                COL         10
                WIDTH       75
                HEIGHT      25
                CAPTION     "Change"
                ONCLICK     Win_Main.Tab1.VALUE := 3
            END BUTTON
            
            DEFINE LABEL    P1_Lbl4
            	ROW         185
                COL         100
                VALUE       "Change to Page 3"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL
        
        END PAGE

        DEFINE PAGE "Page 2"
           // NOTE: Some controls, like PANEL, will display when the host 
           // window is activated regardless of which Page they are on. A
           // workaround is to use the ONINIT property of Win_Main to
           // specifically select a page on program launch
           DEFINE WINDOW    Win_Panel_1 ;
                	ROW     30          ;
                	COL     10          ;
                	WIDTH   450         ;
                	HEIGHT  210         ;
                	WINDOWTYPE PANEL
            
                    DEFINE LABEL    P2_LblDesc
                		ROW         10
                		COL         10
                		VALUE       "Panel Window Inside a Tab."
                		AUTOSIZE    .T.
                        TRANSPARENT .T.
                	END LABEL
            END WINDOW
            
            DEFINE LABEL P2_Lbl1
            	ROW    310
                COL     10
                VALUE  "A LABEL outside the PANEL but only part of Page 1"
                AUTOSIZE  .T.
                TRANSPARENT .T.
            END LABEL        
        END PAGE
        
		DEFINE PAGE "Page 3"
        
            DEFINE LABEL    P3_LblDesc
            	ROW         30
                COL         10
                VALUE       "Further Tests..."
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL        
        
            DEFINE BUTTON   P3_Btn1
                PARENT      Win_Main
                ROW         60
                COL         10
                WIDTH       75
                HEIGHT      25
                CAPTION     "Back"
                ONCLICK     Win_Main.Tab1.VALUE := 1
            END BUTTON
            
            DEFINE LABEL    P3_Lbl1
            	ROW         65
                COL         100
                VALUE       "Back to Page 1"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL

            DEFINE BUTTON   P3_Btn2
                PARENT      Win_Main
                ROW         100
                COL         10
                WIDTH       75
                HEIGHT      25
                CAPTION     "Insert"
                ONCLICK     Win_Main.Tab1.ADDPAGE(4, "Page Y")
            END BUTTON
            
            DEFINE LABEL    P3_Lbl2
            	ROW         105
                COL         100
                VALUE       "Insert a Page"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL

            DEFINE BUTTON   P3_Btn3
                PARENT      Win_Main
                ROW         140
                COL         10
                WIDTH       75
                HEIGHT      25
                CAPTION     "Delete"
                ONCLICK     Win_Main.Tab1.DELETEPAGE(4)
            END BUTTON
            
            DEFINE LABEL    P3_Lbl3
            	ROW         145
                COL         100
                VALUE       "Delete a new Page"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL

            DEFINE BUTTON   P3_Btn4
                PARENT      Win_Main
                ROW         180
                COL         10
                WIDTH       75
                HEIGHT      25
                CAPTION     "New"
                ONCLICK     AddAControl()
            END BUTTON
            
            DEFINE LABEL    P3_Lbl4
            	ROW         185
                COL         100
                VALUE       "Add a new Control"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL

            DEFINE BUTTON   P3_Btn5
                PARENT      Win_Main
                ROW         220
                COL         10
                WIDTH       75
                HEIGHT      25
                CAPTION     "Hide/Show"
                ONCLICK     HideShow()
            END BUTTON
            
            DEFINE LABEL    P3_Lbl5
            	ROW         225
                COL         100
                VALUE       "HIDE / SHOW the Tabs"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL
            
        END PAGE
       
		DEFINE PAGE "Page 4"
            DEFINE LABEL P4_Lbl1
            	ROW    30
                COL    10
                VALUE  "This is a LABEL Control"
                AUTOSIZE    .T.
                TRANSPARENT .T.
            END LABEL        
        END PAGE
		
    END TAB

END WINDOW    // Win_Main

ACTIVATE WINDOW Win_Main

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION HideShow()

Win_Main.Tab1.HIDE

MESSAGEBOXTIMEOUT("Tabs are now hidden. Wait a few seconds...", ;
                  "Timeout Box - HIDE / SHOW TABS", , 3500)

Win_Main.Tab1.SHOW

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION AddAControl()

// Can check if the new control is already defined and
// take appropriate action
IF ISCONTROLDEFINED( LblNew, Win_Main)
    MSGINFO("New Control already defined")
    RETURN nil
ENDIF

// Code above will never run! Disabling the Button to invoke
// this Function, below. Code left in above for reference...
Win_Main.Tab1(3).P3_Btn4.ENABLED := .F.

DEFINE BUTTON   BtnNew
    PARENT      Win_Main
    ROW         180
    COL         100
    WIDTH       75
    HEIGHT      25
    CAPTION     "RELEASE"
    ONCLICK     RelNew()
END BUTTON

DEFINE LABEL    LblNew
    PARENT      Win_Main
    ROW         185
    COL         100
    VALUE       "Release the NEW Button!"
    AUTOSIZE    .T.
    TRANSPARENT .T.
END LABEL

// Add the Control with the ADDCONTROL Method
// Use the RELEASE Method, if needed, to "delete" it
Win_Main.Tab1.ADDCONTROL("BtnNew", 3, 180, 240)
Win_Main.Tab1.ADDCONTROL("LblNew", 3, 185, 330)

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION RelNew()

Win_Main.Tab1(3).BtnNew.RELEASE
Win_Main.Tab1(3).LblNew.RELEASE
Win_Main.Tab1(3).P3_Btn4.ENABLED := .T.

RETURN nil

/* -------------------------------------------------------------------- */