/* ----------------------------------------------------------------------
*  HGM Extended Help Documentation                                      *
*                                                                       *
* Copyright - 2021 - Stuart Aitken - www.harbour-guide.com              *
*                                                                       *
* Username at www.hmgforum.com - Zimbo                                  *
*                                                                       *
* ----------------------------------------------------------------------*/

#include "hmg.ch"

/* -------------------------------------------------------------------- */

FUNCTION Main()

DEFINE WINDOW       Win_1           ;
    ROW             10              ;
    COL             10              ;
    WIDTH           500             ;
    HEIGHT          300             ;
    TITLE           "The SET WINDOW TRANSPARENT Command" ;
    ICON            "HMG Guide.ico" ;
    WINDOWTYPE      MAIN            ;
    FONTNAME        "Arial"         ;
    FONTSIZE        8               ;

    DEFINE LABEL    lbl1
        ROW         2
        COL         75
        FONTSIZE    10
        VALUE       "SET WIN TO COLOR"
        AUTOSIZE    .T.
        TRANSPARENT .T.
        TOOLTIP     "SET WINDOW <FormName> TRANSPARENT TO COLOR <aRGBColor>"
    END LABEL
    
    DEFINE LABEL    lbl2
        ROW         2
        COL         270
        FONTSIZE    10
        VALUE       "SET WIN TO ALPHA"
        AUTOSIZE    .T.
        TRANSPARENT .T.
        TOOLTIP     "SET WINDOW <FormName> TRANSPARENT TO <nAlphaBlend>"
    END LABEL    
    
    DEFINE BUTTON btnSetCol1
        ROW         20
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinCol(1)
        CAPTION     "SET COLOR RED"
        FONTNAME    "Arial"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnSetCol2
        ROW         45
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinCol(2)
        CAPTION     "SET COLOR GREEN"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnSetCol3
        ROW         70
        COL         75
        WIDTH       125
        HEIGHT      22
        ACTION      WinCol(3)
        CAPTION     "SET COLOR BLUE"
        TRANSPARENT .T.
    END BUTTON
    
    DEFINE BUTTON btnSetCol4
        ROW         20
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinCol(4)
        CAPTION     "SET ALPHA 225"
        TRANSPARENT .T.
    END BUTTON    
    
    DEFINE BUTTON btnSetCol5
        ROW         45
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinCol(5)
        CAPTION     "SET ALPHA 125"
        FONTNAME    "Arial"
        TRANSPARENT .T.
    END BUTTON

    DEFINE BUTTON btnSetCol6
        ROW         70
        COL         270
        WIDTH       125
        HEIGHT      22
        ACTION      WinCol(6)
        CAPTION     "SET ALPHA OPAQUE"
        TRANSPARENT .T.
    END BUTTON    

END WINDOW

ACTIVATE WINDOW Win_1

RETURN nil

/* -------------------------------------------------------------------- */

FUNCTION WinCol(nWhich)                  

DO CASE
    CASE nWhich == 1
        SET WINDOW Win_1 TRANSPARENT TO COLOR { 255, 0, 0 }     // RED
    CASE nWhich == 2
        SET WINDOW Win_1 TRANSPARENT TO COLOR { 0, 255, 0 }     // GREEN
    CASE nWhich == 3
        SET WINDOW Win_1 TRANSPARENT TO COLOR { 0, 0, 255 }     // BLUE
    CASE nWhich == 4
        SET WINDOW Win_1 TRANSPARENT TO 225
    CASE nWhich == 5
        SET WINDOW Win_1 TRANSPARENT TO 125
    CASE nWhich == 6
        SET WINDOW Win_1 TO OPAQUE
ENDCASE

RETURN nil

/* -------------------------------------------------------------------- */
